## BDLedger API

### Documentation

See [API documentation](..\docs\apis.md)

### Development

#### Generating gRPC code in languages

##### Installling tools

Download the [Protocol Buffers compiler](https://github.com/protocolbuffers/protobuf/releases) (protoc-3.13.0-*) for your platform and add `protoc` to `PATH` environment variable 

For generating Go code, install `protoc-gen-go` (v1.4.3):
```bash
GIT_TAG="v1.4.3"
go get -d -u google.golang.org/protobuf/cmd/protoc-gen-go
git -C "$(go env GOPATH)"/src/google.golang.org/protobuf checkout $GIT_TAG
go install google.golang.org/protobuf/cmd/protoc-gen-go
```

Also install `protoc-gen-go-grpc`:
```bash
go get -u google.golang.org/protobuf/cmd/protoc-gen-go
```

Or install using [gobin](https://github.com/myitcv/gobin):
```bash
gobin google.golang.org/protobuf/cmd/protoc-gen-go
gobin google.golang.org/grpc/cmd/protoc-gen-go-grpc
```

For generating HTTP JSON APIs with [grpc-gateway](https://grpc-ecosystem.github.io/grpc-gateway/), follow the [documentation](https://github.com/grpc-ecosystem/grpc-gateway/tree/v2#installation).

For generating Java code: From `bdledger-sdk-java` run `gradle generateProto`

For generating Node.js code (and TypeScript definitions), install Node.js then run:
```bash
npm install
```

For frontend JavaScript:
```bash
git clone https://github.com/grpc/grpc-web
cd grpc-web
sudo make install-plugin
```

References:
- [Go Quick Start](https://grpc.io/docs/quickstart/go.html#prerequisites)
- [gRPC Go FAQ](https://github.com/grpc/grpc-go#faq)

**TODO: Look into [protobuf.js](https://github.com/protobufjs/protobuf.js) for Nodes.js and frontend**
**TODO: Look into [Kroto+](https://github.com/marcoferrer/kroto-plus) for Kotlin**

##### Generating code

Run:
```bash
./scripts/gen [-a, --async] [go] [gohttp] [nodejs] [ts] [docs]
```
Use `-a` or `--async` to speed up generation by asynchronously and concurrently generating all code and documentation (script will exit without waiting for completion)

#### Generateing documentation

Install Go then run:

```bash
go get -u github.com/pseudomuto/protoc-gen-doc/cmd/protoc-gen-doc
./scripts/gen [-a, --async] docs
```
